﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Grids;
using Infragistics.Olap;

namespace Pivot_tasks
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        public void ExpandAllHeaders(XamPivotGrid pivotGrid, Action callback = null)
        {
            var filterViewModels = pivotGrid.DataSource.Rows.Concat(pivotGrid.DataSource.Columns).Where(fvm => fvm is IFilterViewModel).ToList();

            for (int i = 0; i < filterViewModels.Count; i++)
            {
                var filterViewModel = filterViewModels[i] as IFilterViewModel;

                if (filterViewModel == null)
                    return;

                if (i == filterViewModels.Count - 1)
                {
                    EventHandler<ResultChangedEventArgs> handler = null;
                    handler = (sender, e) =>
                    {
                        pivotGrid.DataSource.ResultChanged -= handler;
                        if (callback != null)
                            callback();
                    };
                    pivotGrid.DataSource.ResultChanged += handler;

                    ((DataSourceBase)pivotGrid.DataSource).ExpandToLevelAsync(filterViewModel, filterViewModel.Hierarchy.Levels.Count - 1).ContinueWith(t => { pivotGrid.DataSource.RefreshGrid(); }, System.Threading.Tasks.TaskContinuationOptions.ExecuteSynchronously);
                }
                else
                {
                    ((DataSourceBase)pivotGrid.DataSource).ExpandToLevelAsync(filterViewModel, filterViewModel.Hierarchy.Levels.Count - 1);
                }
            }
        }
         

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            ExpandAllHeaders(pivotGrid1, () => ExpandAllHeaders(pivotGrid2));
        }



    }

 
}
